import queue
import sys
import argparse
import time
import random

nb_plats = {
    "Obelix": 4,
    "Asterix": 1,
    "Abraracourcix": 2,
    "Jolitorax": 1,
    "Pepe": 2,
    "Zebigbos": 3,
    "Cétautomatix": 2,
    "Amérix": 1,
    "Alambix": 1,
    "Gueuselambix": 4,
    "Vanendfaillevesix": 4,
    "Beaufix": 1, 
}

phrases_romaines = [
    "vae victis", "quid novi", "sursum corda", "'Alea zacta eft !", "Acta est fabula", "Beati pauperes spiritu"
]

plats = ["sanglier roti", "sanglier farci", "sanglier grillé", "sanglier chasseur"]

banquet_termine = False

def temp():
    """Pour attendre un temps aléatoire
    """
    time.sleep(random.random()/10)

def frappe_romain(nom):
    """
    nom frappe un romain
    """
    temp()
    i = random.randrange(len(phrases_romaines))
    print(f"{nom} frappe un romain : {phrases_romaines[i]}")

def mange(nom, liste_plats):
    """
    nom mange tous les plat de la liste
    """
    for plat in liste_plats:
        temp()
        print(f"{nom} mange {plat}")

def prepare():
    i = random.randrange(len(plats))
    return plats[i]

def cuisinier(nb_plats, plats_prets):
    """
    Thread de la cuisine qui prépare nb_plats plats et les place dans la liste
    """
    global banquet_termine
    for i in range(nb_plats):
        plats_prets.append(prepare())
    print("Cuisine : et si on chantait ?")
    banquet_termine = True

def convive(nom, plats_prets):
    """
    Thread d'un participant au banquet, il mange et ensuite tape un romain jusqu'à la fin du banquet
    """
    print(f"{nom}: debut")
    besoin = nb_plats[nom]
    while True:
        ps = []
        if len(plats_prets) >= besoin:
            # Il y a assez de plat
            print(f"{nom} peut prendre {besoin} plats")

            # récupération des plats
            for i in range(besoin):
                temp()
                ps.append(plats_prets.pop())

            print(f"{nom} a eu {', '.join(ps)}")

        # consomation si le convive n'a pas de plat ça ne fait rien
        mange(nom, ps)
        
        frappe_romain(nom)

        # on s'arrete si la cuisine est fermée et qu'il n'y a plus assez de plats
        if banquet_termine and besoin>len(plats_prets):
            break
    print(f"{nom}: fin")

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description="Simule le banquet")
    parser.add_argument("-n", "--nb-plats", dest="nb", default=25, type=int, help="Nombre de plats à préparer")
    
    args = parser.parse_args()

    # nombre de plats à préparer
    nb = args.nb
    # liste des convives
    convives = nb_plats.keys()
    # echange entre la cuisine et les convives
    plats_prets = []

    # on lance la cuisine
    cuisinier(nb, plats_prets)

    # on lance les gaulois
    for n in convives:
        convive(n, plats_prets)
    
    print(f"Fin du banquet")